Index: branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.cs
===================================================================
--- branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.cs	(revision 16234)
+++ branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectJobsView.cs	(revision 16235)
@@ -24,4 +24,5 @@
 using System.Drawing;
 using System.Linq;
+using System.Threading.Tasks;
 using System.Windows.Forms;
 using HeuristicLab.MainForm;
@@ -30,4 +31,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.Clients.Hive.Views;
+using HeuristicLab.Core;
 
 namespace HeuristicLab.Clients.Hive.Administrator.Views {
@@ -41,9 +43,11 @@
     private const string JOB_DATECREATED = "Date Created";
     private const string JOB_STATE = "State";
+    private const string JOB_EXECUTIONSTATE = "Execution State";
+    private const string JOB_EXECUTIONTIME = "Execution Time";
     private const string JOB_DESCRIPTION = "Description";
     private const string JOB_TASKCOUNT = "Tasks";
+    private const string JOB_WAITINGTASKCOUNT = "Waiting";
     private const string JOB_CALCULATINGTASKCOUNT = "Calculating";
     private const string JOB_FINISHEDTASKCOUNT = "Finished";
-
 
     private readonly Color onlineStatusColor = Color.FromArgb(255, 189, 249, 143); // #bdf98f
@@ -53,4 +57,13 @@
     private readonly Color deletionPendingStatusColor2 = Color.FromArgb(255, 249, 149, 143); // #f9958f
 
+    private IProgress progress;
+    public IProgress Progress {
+      get { return progress; }
+      set {
+        this.progress = value;
+        OnIsProgressingChanged();
+      }
+    }
+
     public new Project Content {
       get { return (Project)base.Content; }
@@ -60,18 +73,23 @@
     public ProjectJobsView() {
       InitializeComponent();
-
-      removeButton.Enabled = false;
+      progress = new Progress();
+
+      removeButton.Enabled = false;      
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
       matrixView.DataGridView.SelectionChanged += DataGridView_SelectionChanged;
+      MainFormManager.GetMainForm<HeuristicLab.MainForm.WindowsForms.MainForm>().AddOperationProgressToView(this, progress);
+    }
+
+    protected override void DeregisterContentEvents() {
+      matrixView.DataGridView.SelectionChanged -= DataGridView_SelectionChanged;
+      MainFormManager.GetMainForm<HeuristicLab.MainForm.WindowsForms.MainForm>().RemoveOperationProgressFromView(this, false);
+      base.DeregisterContentEvents();
     }
 
     private void DataGridView_SelectionChanged(object sender, EventArgs e) {
-      if (matrixView.DataGridView.SelectedRows == null || matrixView.DataGridView.SelectedRows.Count == 0) return;
-
-      bool anyDeletable = false;
-      foreach (DataGridViewRow r in matrixView.DataGridView.SelectedRows) {
-        if (((string)r.Cells[0].Value) == JobState.Online.ToString()) anyDeletable = true;
-      }
-
-      removeButton.Enabled = anyDeletable;
+      SetEnabledStateOfControls();
     }
 
@@ -81,13 +99,36 @@
       removeButton.Enabled = false;
       UpdateJobs();
-    }
+      SetEnabledStateOfControls();
+    }
+
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
       bool enabled = Content != null && !Locked && !ReadOnly;
 
-      refreshButton.Enabled = enabled;
-      removeButton.Enabled = false;
       matrixView.Enabled = enabled;
-    }
+
+      // Buttons (start/resume, pause, stop, remove)
+      refreshButton.Enabled = startButton.Enabled = pauseButton.Enabled = stopButton.Enabled = removeButton.Enabled = false;
+
+      if (enabled && progress.ProgressState != ProgressState.Started) {
+        var jobs = GetSelectedJobs().ToList();
+        if (jobs.Any()) {
+                    
+          startButton.Enabled = jobs.All(x =>
+            !x.IsProgressing && HiveAdminClient.Instance.Tasks.ContainsKey(x.Id) && HiveAdminClient.Instance.Tasks[x.Id].Count > 0
+            && x.Job.ProjectId != Guid.Empty //&& x.Job.ResourceIds != null && x.Job.ResourceIds.Any()
+            && (x.ExecutionState == ExecutionState.Prepared || x.ExecutionState == ExecutionState.Paused));
+          pauseButton.Enabled = jobs.All(x => !x.IsProgressing && x.ExecutionState == ExecutionState.Started);
+          stopButton.Enabled = jobs.All(x => !x.IsProgressing && (x.ExecutionState == ExecutionState.Started || x.ExecutionState == ExecutionState.Paused));
+          removeButton.Enabled = jobs.All(x => !x.IsProgressing && x.Job.State == JobState.Online);
+        }
+      }
+
+      // refresh Button
+      if (Content != null && !Locked && progress.ProgressState != ProgressState.Started) {
+        refreshButton.Enabled = true;
+      }
+    }
+
     #endregion Overrides
 
@@ -98,22 +139,20 @@
 
     private void refreshButton_Click(object sender, EventArgs e) {
-      RefreshJobs();
-    }
-
-    private async void removeButton_Click(object sender, EventArgs e) {
-      if (matrixView.DataGridView.SelectedRows == null || matrixView.DataGridView.SelectedRows.Count == 0) return;
-
-      var jobNamesToDelete = new List<string>();
-      var jobIdsToDelete = new List<Guid>();
-      foreach (DataGridViewRow r in matrixView.DataGridView.SelectedRows) {
-        if(((string)r.Cells[0].Value) == JobState.Online.ToString()) {
-          jobNamesToDelete.Add(" - " + ((string)r.Cells[3].Value));
-          jobIdsToDelete.Add(Guid.Parse((string)r.Cells[8].Value));
-        }
-      }
-
-      if(jobIdsToDelete.Any()) {
+      progress.Start("Refreshing jobs...");
+      SetEnabledStateOfControls();
+      var task = System.Threading.Tasks.Task.Factory.StartNew(RefreshJobsAsync);
+
+      task.ContinueWith((t) => {
+        progress.Finish();        
+        SetEnabledStateOfControls();
+      });
+    }
+
+    private void removeButton_Click(object sender, EventArgs e) {
+      var jobs = GetSelectedJobs();
+
+      if (jobs.Any()) {
         var result = MessageBox.Show("Do you really want to remove following job(s):\n\n"
-          + String.Join("\n", jobNamesToDelete),
+                                     + String.Join("\n", jobs.Select(x => x.Job.Name)),
           "HeuristicLab Hive Administrator",
           MessageBoxButtons.YesNo,
@@ -121,23 +160,144 @@
 
         if (result == DialogResult.Yes) {
-          await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
-            action: () => {
-              DeleteJobs(jobIdsToDelete);
-            },
-            finallyCallback: () => {
-              matrixView.DataGridView.ClearSelection();
-              removeButton.Enabled = false;
-              RefreshJobs();
-            });
-        }
-      } 
-    }
-
+          progress.Start("Removing job(s)...");
+          SetEnabledStateOfControls();
+          var task = System.Threading.Tasks.Task.Factory.StartNew(RemoveJobsAsync, jobs);
+
+          task.ContinueWith((t) => {
+            RefreshJobs();
+            progress.Finish();
+            SetEnabledStateOfControls();
+          }, TaskContinuationOptions.NotOnFaulted);
+
+          task.ContinueWith((t) => {
+            RefreshJobs();
+            progress.Finish();
+            SetEnabledStateOfControls();
+            MessageBox.Show("An error occured removing the job(s).", "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Error);
+          }, TaskContinuationOptions.OnlyOnFaulted);
+        }
+      }
+    }
+
+    private void startButton_Click(object sender, EventArgs e) {
+      var jobs = GetSelectedJobs();
+
+      if (jobs.Any()) {
+        var result = MessageBox.Show("Do you really want to resume following job(s):\n\n"
+                                     + String.Join("\n", jobs.Select(x => x.Job.Name)),
+          "HeuristicLab Hive Administrator",
+          MessageBoxButtons.YesNo,
+          MessageBoxIcon.Question);
+
+        if (result == DialogResult.Yes) {
+          progress.Start("Resuming job(s)...");
+          SetEnabledStateOfControls();
+          var task = System.Threading.Tasks.Task.Factory.StartNew(ResumeJobsAsync, jobs);
+
+          task.ContinueWith((t) => {
+            RefreshJobs();            
+            progress.Finish();
+            SetEnabledStateOfControls();
+          }, TaskContinuationOptions.NotOnFaulted);
+
+          task.ContinueWith((t) => {
+            RefreshJobs();
+            progress.Finish();
+            SetEnabledStateOfControls();
+            MessageBox.Show("An error occured resuming the job(s).", "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Error);
+          }, TaskContinuationOptions.OnlyOnFaulted);
+        }
+      }
+    }
+
+    private void pauseButton_Click(object sender, EventArgs e) {
+      var jobs = GetSelectedJobs();
+
+      if (jobs.Any()) {
+        var result = MessageBox.Show("Do you really want to pause following job(s):\n\n"
+                                     + String.Join("\n", jobs.Select(x => x.Job.Name)),
+          "HeuristicLab Hive Administrator",
+          MessageBoxButtons.YesNo,
+          MessageBoxIcon.Question);
+
+        if (result == DialogResult.Yes) {
+          progress.Start("Pausing job(s)...");
+          SetEnabledStateOfControls();
+          var task = System.Threading.Tasks.Task.Factory.StartNew(PauseJobsAsync, jobs);
+
+          task.ContinueWith((t) => {
+            RefreshJobs();            
+            progress.Finish();
+            SetEnabledStateOfControls();
+          }, TaskContinuationOptions.NotOnFaulted);
+
+          task.ContinueWith((t) => {
+            RefreshJobs();
+            progress.Finish();
+            SetEnabledStateOfControls();
+            MessageBox.Show("An error occured pausing the job(s).", "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Error);
+          }, TaskContinuationOptions.OnlyOnFaulted);
+        }
+      }
+    }
+
+    private void stopButton_Click(object sender, EventArgs e) {
+      var jobs = GetSelectedJobs();
+
+      if (jobs.Any()) {
+        var result = MessageBox.Show("Do you really want to stop following job(s):\n\n"
+                                     + String.Join("\n", jobs.Select(x => x.Job.Name)),
+          "HeuristicLab Hive Administrator",
+          MessageBoxButtons.YesNo,
+          MessageBoxIcon.Question);
+
+        if (result == DialogResult.Yes) {
+          progress.Start("Stopping job(s)...");
+          SetEnabledStateOfControls();
+          var task = System.Threading.Tasks.Task.Factory.StartNew(StopJobsAsync, jobs);
+
+          task.ContinueWith((t) => {
+            RefreshJobs();
+            progress.Finish();
+            SetEnabledStateOfControls();
+          }, TaskContinuationOptions.NotOnFaulted);
+
+          task.ContinueWith((t) => {
+            RefreshJobs();
+            progress.Finish();
+            SetEnabledStateOfControls();
+            MessageBox.Show("An error occured stopping the job(s).", "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Error);            
+          }, TaskContinuationOptions.OnlyOnFaulted);
+        }
+      }
+    }
+
+    public event EventHandler IsProgressingChanged;
+    private void OnIsProgressingChanged() {
+      var handler = IsProgressingChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
     #endregion Event Handlers
 
     #region Helpers
+
+    private IEnumerable<RefreshableJob> GetSelectedJobs() {
+      if (Content == null || matrixView.DataGridView.SelectedRows == null || matrixView.DataGridView.SelectedRows.Count == 0)
+        return Enumerable.Empty<RefreshableJob>() ;
+
+      var jobs = new List<RefreshableJob>();
+      foreach (DataGridViewRow r in matrixView.DataGridView.SelectedRows) {
+        if (((string)r.Cells[0].Value) == JobState.Online.ToString()) {
+          jobs.Add(HiveAdminClient.Instance.Jobs[Content.Id].FirstOrDefault(x => x.Id == Guid.Parse((string) r.Cells[11].Value)));
+        }
+      }
+
+      return jobs;
+    }
+
     private void RefreshJobs() {
       HiveAdminClient.Instance.RefreshJobs();
       UpdateJobs();
+      SetEnabledStateOfControls();
     }
 
@@ -148,23 +308,25 @@
       var jobs = HiveAdminClient.Instance.Jobs[Content.Id];
       var resources = HiveAdminClient.Instance.Resources;
-      string[,] values = new string[jobs.Count, 10];
+      string[,] values = new string[jobs.Count, 13];
 
       for(int i = 0; i < jobs.Count; i++) {
-        var job = jobs.ElementAt(i);
-        
-        values[i, 0] = job.State.ToString();
-        values[i, 1] = job.DateCreated.ToString();
-        values[i, 2] = job.OwnerUsername;
-        values[i, 3] = job.Name;
-        values[i, 4] = job.JobCount.ToString();
-        values[i, 5] = job.CalculatingCount.ToString();
-        values[i, 6] = job.FinishedCount.ToString();
-        values[i, 7] = job.Description;        
-        values[i, 8] = job.Id.ToString();
-        values[i, 9] = job.OwnerUserId.ToString();
+        var job = jobs.ElementAt(i);        
+        values[i, 0] = job.Job.State.ToString();
+        values[i, 1] = job.ExecutionState.ToString();
+        values[i, 2] = job.ExecutionTime.ToString();
+        values[i, 3] = job.Job.DateCreated.ToString();
+        values[i, 4] = job.Job.OwnerUsername;
+        values[i, 5] = job.Job.Name;
+        values[i, 6] = job.Job.JobCount.ToString();
+        values[i, 7] = (job.Job.JobCount - job.Job.CalculatingCount - job.Job.FinishedCount).ToString();
+        values[i, 8] = job.Job.CalculatingCount.ToString();
+        values[i, 9] = job.Job.FinishedCount.ToString();
+        values[i, 10] = job.Job.Description;        
+        values[i, 11] = job.Job.Id.ToString();
+        values[i, 12] = job.Job.OwnerUserId.ToString();
       }
       
       var matrix = new StringMatrix(values);
-      matrix.ColumnNames = new string[] { JOB_STATE, JOB_DATECREATED, JOB_OWNER, JOB_NAME, JOB_TASKCOUNT, JOB_CALCULATINGTASKCOUNT, JOB_FINISHEDTASKCOUNT, JOB_DESCRIPTION, JOB_ID, JOB_OWNERID };
+      matrix.ColumnNames = new string[] { JOB_STATE, JOB_EXECUTIONSTATE, JOB_EXECUTIONTIME, JOB_DATECREATED, JOB_OWNER, JOB_NAME, JOB_TASKCOUNT, JOB_WAITINGTASKCOUNT, JOB_CALCULATINGTASKCOUNT, JOB_FINISHEDTASKCOUNT, JOB_DESCRIPTION, JOB_ID, JOB_OWNERID };
       matrix.SortableView = true;
       return matrix;
@@ -193,18 +355,45 @@
             matrixView.DataGridView.Columns[1].MinimumWidth = 108;
           }
-        } else {
-          refreshButton.Enabled = false;
-          removeButton.Enabled = false;
-          matrixView.Content = null;
-        }
-      }
-    }
-
-    private void DeleteJobs(List<Guid> jobIds) {
-      try {
-        HiveAdminClient.DeleteJobs(jobIds);
-      } catch (AnonymousUserException) {
-        ShowHiveInformationDialog();
-      }
+        } 
+      }
+    }
+
+    private void RefreshJobsAsync() {
+      HiveAdminClient.Instance.RefreshJobs();
+      UpdateJobs();
+    }
+
+    private void ResumeJobsAsync(object jobs) {
+      var jobList = (IEnumerable<RefreshableJob>)jobs;
+      foreach (var job in jobList) {
+        progress.Status = "Resuming job \"" + job.Job.Name + "\"...";
+        HiveAdminClient.ResumeJob(job);
+      }
+    }
+
+    private void PauseJobsAsync(object jobs) {
+      var jobList = (IEnumerable<RefreshableJob>)jobs;
+      foreach (var job in jobList) {
+        progress.Status = "Pausing job \"" + job.Job.Name + "\"...";
+        HiveAdminClient.PauseJob(job);
+      }
+    }
+
+    private void StopJobsAsync(object jobs) {
+      var jobList = (IEnumerable<RefreshableJob>) jobs;
+      foreach (var job in jobList) {        
+        progress.Status = "Stopping job \"" + job.Job.Name + "\"...";
+        HiveAdminClient.StopJob(job);
+      }
+    }
+
+    private void RemoveJobsAsync(object jobs) {
+      var jobList = (IEnumerable<RefreshableJob>)jobs;
+      progress.Start();
+      foreach (var job in jobList) {
+        progress.Status = "Removing job \"" + job.Job.Name + "\"...";
+        HiveAdminClient.RemoveJob(job);
+      }
+      progress.Finish();
     }
 
Index: branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectPermissionsView.cs
===================================================================
--- branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectPermissionsView.cs	(revision 16234)
+++ branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectPermissionsView.cs	(revision 16235)
@@ -78,7 +78,7 @@
         detailsViewHost.Content = null;
       } else {
-        UpdatePermissionList();
-        detailsViewHost.ActiveView.Locked = true;
-      }
+        UpdatePermissionList();        
+      }
+      SetEnabledStateOfControls();
     }
 
@@ -90,4 +90,9 @@
       saveButton.Enabled = enabled;
       treeView.Enabled = enabled;
+
+      if (detailsViewHost != null) {
+        detailsViewHost.Locked = true;
+      }
+
     }
     #endregion
Index: branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.cs
===================================================================
--- branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.cs	(revision 16234)
+++ branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.cs	(revision 16235)
@@ -30,4 +30,5 @@
 using HeuristicLab.MainForm;
 using System.Collections;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Clients.Hive.Administrator.Views {
@@ -72,7 +73,16 @@
       treeView.ImageList.Images.Add(VSImageLibrary.MonitorLarge);
       treeView.ImageList.Images.Add(VSImageLibrary.NetworkCenterLarge);
+
+      HiveAdminClient.Instance.Refreshing += HiveAdminClient_Instance_Refreshing;
+      HiveAdminClient.Instance.Refreshed += HiveAdminClient_Instance_Refreshed;
     }
 
     #region Overrides
+    protected override void OnClosing(FormClosingEventArgs e) {
+      HiveAdminClient.Instance.Refreshed -= HiveAdminClient_Instance_Refreshed;
+      HiveAdminClient.Instance.Refreshing -= HiveAdminClient_Instance_Refreshing;
+      base.OnClosing(e);
+    }
+
     protected override void OnContentChanged() {
       base.OnContentChanged();
@@ -86,8 +96,7 @@
         UpdateAssignedResources();
         UpdateIncludedResources();
-        var top = BuildResourceTree();
-        detailsViewHost.Content = top;
-        detailsViewHost.Locked = true;
-      }
+        detailsViewHost.Content = BuildResourceTree();
+      }
+      SetEnabledStateOfControls();
     }
 
@@ -99,8 +108,26 @@
       saveButton.Enabled = enabled;
       treeView.Enabled = enabled;
+
+      if (detailsViewHost != null) {
+        detailsViewHost.Locked = true;
+      }
     }
     #endregion
 
     #region Event Handlers
+    private void HiveAdminClient_Instance_Refreshing(object sender, EventArgs e) {
+      if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshing, sender, e);
+      else {
+        SetEnabledStateOfControls();
+      }
+    }
+
+    private void HiveAdminClient_Instance_Refreshed(object sender, EventArgs e) {
+      if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshed, sender, e);
+      else {
+        OnContentChanged();
+      }
+    }
+
     private void ProjectResourcesView_Load(object sender, EventArgs e) {
 
@@ -382,5 +409,5 @@
         }
 
-          if (includedResources.Contains(newResource) && newIncludedResources.Contains(newResource)) {
+        if (includedResources.Contains(newResource) && newIncludedResources.Contains(newResource)) {
           newNode.Text += INCLUDED_TAG;
         } else if (addedIncludes.Contains(newResource)) {
@@ -421,4 +448,7 @@
       }
 
+      ExpandResourceNodesOfInterest(treeView.Nodes);
+
+      bool expandUngroupedGroupNode = false;
       var ungroupedSlaves = subResources.OfType<Slave>().OrderBy(x => x.Name);
       if(ungroupedSlaves.Any()) {
@@ -433,6 +463,28 @@
         foreach (var slave in ungroupedSlaves) {
           var slaveNode = new TreeNode(slave.Name) { Tag = slave };
+          if (newAssignedResources.Contains(slave)) {
+            slaveNode.Checked = true;
+            expandUngroupedGroupNode = true;
+          }
+
+          if (!HiveRoles.CheckAdminUserPermissions()) {
+            slaveNode.ForeColor = SystemColors.GrayText;
+            slaveNode.Text += IMMUTABLE_TAG;
+          } else {
+            if (addedAssignments.Contains(slave)) {
+              slaveNode.BackColor = addedAssignmentColor;
+              slaveNode.ForeColor = SystemColors.ControlText;
+              slaveNode.Text += ADDED_ASSIGNMENT_TAG;
+            } else if (removedAssignments.Contains(slave)) {
+              slaveNode.BackColor = removedAssignmentColor;
+              slaveNode.ForeColor = SystemColors.ControlText;
+              slaveNode.Text += REMOVED_ASSIGNMENT_TAG;
+              expandUngroupedGroupNode = true;
+            }
+          }
           ungroupedGroupNode.Nodes.Add(slaveNode);
         }
+
+        if(expandUngroupedGroupNode) ungroupedGroupNode.Expand();
         treeView.Nodes.Add(ungroupedGroupNode);
       } else if (ungroupedGroupNode != null) {
@@ -441,7 +493,5 @@
 
       treeView.BeforeCheck += treeView_BeforeCheck;
-      treeView.AfterCheck += treeView_AfterCheck;
-      
-      ExpandResourceNodesOfInterest(treeView.Nodes);
+      treeView.AfterCheck += treeView_AfterCheck;          
 
       return top;
Index: branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs
===================================================================
--- branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 16234)
+++ branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 16235)
@@ -118,4 +118,5 @@
         endDateTimePicker.Enabled = !indefiniteCheckBox.Checked;
       }
+      SetEnabledStateOfControls();
       RegisterControlEvents();
     }
@@ -134,10 +135,12 @@
 
       if (Content != null) {
-        var parentProject = HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).LastOrDefault();
-        if (parentProject == null || parentProject.EndDate.HasValue) {
+        //var parentProject = HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).LastOrDefault();
+        var parentProject = HiveAdminClient.Instance.Projects.FirstOrDefault(x => x.Id == Content.ParentProjectId);
+        if ((!IsAdmin() && (parentProject == null || parentProject.EndDate.HasValue))
+           || (IsAdmin() && parentProject != null && parentProject.EndDate.HasValue)) {
           indefiniteCheckBox.Enabled = false;
         }
 
-        if (!IsAdmin() && !HiveAdminClient.Instance.CheckOwnershipOfParentProject(Content, UserInformation.Instance.User.Id)) {
+        if (Content.Id != Guid.Empty && !IsAdmin() && !HiveAdminClient.Instance.CheckOwnershipOfParentProject(Content, UserInformation.Instance.User.Id)) {
           ownerComboBox.Enabled = false;
           startDateTimePicker.Enabled = false;
Index: branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs
===================================================================
--- branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs	(revision 16234)
+++ branches/2931_OR-Tools_LP_MIP/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs	(revision 16235)
@@ -43,4 +43,5 @@
     private const string NOT_STORED_TAG = "*"; // " [not stored]";
     private const string CHANGES_NOT_STORED_TAG = "*"; // " [changes not stored]";
+    private const string INACTIVE_TAG = " [inactive]"; 
 
     private readonly Color selectedBackColor = Color.DodgerBlue;
@@ -106,31 +107,52 @@
         BuildProjectTree(Content);
       }
+      SetEnabledStateOfControls();
     }
 
     protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      bool selectedProjectExists = selectedProject != null && selectedProject.Id != Guid.Empty && Content.Contains(selectedProject);
-      bool projectIsNew = selectedProject != null && selectedProject.Id == Guid.Empty;
-      bool locked = Content == null || selectedProject == null || Locked || ReadOnly;
-      bool parentOwner = HiveAdminClient.Instance.CheckOwnershipOfParentProject(selectedProject, UserInformation.Instance.User.Id);
-      bool saveLocked = locked || (!IsAdmin() && selectedProject.OwnerUserId != UserInformation.Instance.User.Id && !parentOwner);
-      bool addLocked = saveLocked || projectIsNew || selectedProject.Id == Guid.Empty;
-      bool deleteLocked = locked || (!IsAdmin() && !parentOwner) || Content.Where(x => x.ParentProjectId == selectedProject.Id).Any();
-
-      var now = DateTime.Now;
-      if (!addLocked && (now < selectedProject.StartDate || now > selectedProject.EndDate)) addLocked = true;
+      base.SetEnabledStateOfControls();      
+
+      bool locked = Content == null || Locked || ReadOnly;      
+      bool parentOwner = selectedProject != null && HiveAdminClient.Instance.CheckOwnershipOfParentProject(selectedProject, UserInformation.Instance.User.Id);
+      bool selectedProjectDisabled = selectedProject == null 
+                                     || selectedProject != null && selectedProject.Id == Guid.Empty;
+
+      bool selectedProjectHasJobs =
+        !selectedProjectDisabled && HiveAdminClient.Instance.Jobs.ContainsKey(selectedProject.Id)
+                                 && HiveAdminClient.Instance.Jobs[selectedProject.Id] != null
+                                 && HiveAdminClient.Instance.Jobs[selectedProject.Id].Any();
+
+      bool addLocked = locked
+                       || (selectedProject == null && !IsAdmin())
+                       || (selectedProject != null && selectedProject.Id == Guid.Empty)
+                       || (selectedProject != null && !IsAdmin() && !parentOwner && selectedProject.OwnerUserId != UserInformation.Instance.User.Id)
+                       || (selectedProject != null && (DateTime.Now < selectedProject.StartDate || DateTime.Now > selectedProject.EndDate));
+
+      bool deleteLocked = locked
+                          || !Content.Any()
+                          || selectedProject == null
+                          || Content.Any(x => x.ParentProjectId == selectedProject.Id)
+                          || selectedProjectHasJobs
+                          || (!IsAdmin() && !parentOwner);
+
+      bool saveLocked = locked
+                        || !Content.Any()
+                        || selectedProject == null
+                        || (!IsAdmin() && !parentOwner && selectedProject.OwnerUserId != UserInformation.Instance.User.Id);
+
 
       addButton.Enabled = !addLocked;
       removeButton.Enabled = !deleteLocked;
       saveProjectButton.Enabled = !saveLocked;
+
       projectView.Enabled = !locked;
-      projectPermissionsView.Enabled = !locked;
-      projectResourcesView.Enabled = !locked;
-      projectJobsView.Enabled = !locked;
+      projectPermissionsView.Enabled = !locked && !selectedProjectDisabled;
+      projectResourcesView.Enabled = !locked && !selectedProjectDisabled;
+      projectJobsView.Enabled = !locked && !selectedProjectDisabled;
 
       projectView.Locked = locked;
-      projectPermissionsView.Locked = locked;
-      projectResourcesView.Locked = locked;
-      projectJobsView.Locked = locked;
+      projectPermissionsView.Locked = locked || selectedProjectDisabled;
+      projectResourcesView.Locked = locked || selectedProjectDisabled;
+      projectJobsView.Locked = locked || selectedProjectDisabled;
     }
     #endregion
@@ -254,37 +276,4 @@
       }
 
-      // double check of ChangeSelectedProject(..):
-      // if the user is no admin nor owner of a parent project
-      if (!IsAdmin() && !HiveAdminClient.Instance.CheckOwnershipOfParentProject(selectedProject, UserInformation.Instance.User.Id)) {
-        MessageBox.Show(
-          "Only admins and owners of parent projects are allowed to delete this project.",
-          "HeuristicLab Hive Administrator",
-          MessageBoxButtons.OK,
-          MessageBoxIcon.Error);
-        return;
-      }            
-
-
-      if (Content.Any(x => x.ParentProjectId == selectedProject.Id) 
-          || HiveAdminClient.Instance.ProjectDescendants[selectedProject.Id].Any()) {
-        MessageBox.Show(
-          "Only empty projects can be deleted.",
-          "HeuristicLab Hive Administrator",
-          MessageBoxButtons.OK,
-          MessageBoxIcon.Error);
-        return;
-      }
-
-      if (HiveAdminClient.Instance.Jobs.ContainsKey(selectedProject.Id) 
-        && HiveAdminClient.Instance.Jobs[selectedProject.Id] != null 
-        && HiveAdminClient.Instance.Jobs[selectedProject.Id].Any()) {
-        MessageBox.Show(
-          "There are " + HiveAdminClient.Instance.Jobs[selectedProject.Id].Count + " job(s) using this project and/or child-projects. It is necessary to delete them before the project.",
-          "HeuristicLab Hive Administrator",
-          MessageBoxButtons.OK,
-          MessageBoxIcon.Error);
-        return;
-      }
-
       var result = MessageBox.Show(
         "Do you really want to delete " + selectedProject.Name + "?",
@@ -297,11 +286,7 @@
           action: () => {
             RemoveProject(selectedProject);  
-          },
-          finallyCallback: () => {
-            removeButton.Enabled = true;
           });
-      } else {
-        removeButton.Enabled = true;
-      }
+      }
+      SetEnabledStateOfControls();
     }
 
@@ -492,8 +477,15 @@
       if (HiveAdminClient.Instance.DisabledParentProjects.Select(x => x.Id).Contains(p.Id)) {
         n.ForeColor = grayTextColor;
-      } else if (p.Id == Guid.Empty) {
-        n.Text += NOT_STORED_TAG;
-      } else if (p.Modified) {
-        n.Text += CHANGES_NOT_STORED_TAG;
+      } else {
+        if (p.Id == Guid.Empty) {
+          n.Text += NOT_STORED_TAG;
+        } else if (p.Modified) {
+          n.Text += CHANGES_NOT_STORED_TAG;
+        }
+
+        if (!IsActive(p)) {
+          n.ForeColor = grayTextColor;
+          n.Text += INACTIVE_TAG;
+        }
       }
     }
@@ -540,12 +532,9 @@
       try {
         if (project.Id != Guid.Empty) {
-          var projectsToSave = Content.Where(x => x.Id == Guid.Empty || x.Modified);
-          foreach (var p in projectsToSave)
-            p.Store();
-
           SelectedProject = HiveAdminClient.Instance.GetAvailableProjectAncestors(project.Id).LastOrDefault();
           HiveAdminClient.Delete(project);          
           UpdateProjects();
-        } else {
+        } else {          
+          SelectedProject = Content.FirstOrDefault(x => x.Id == project.ParentProjectId);
           Content.Remove(project);
         }
@@ -553,4 +542,10 @@
         ShowHiveInformationDialog();
       }
+    }
+
+    private bool IsActive(Project project) {
+      return DateTime.Now >= project.StartDate
+             && (project.EndDate == null
+                 || DateTime.Now < project.EndDate.Value);
     }
 
